import { Body, Controller, Del, Get, Inject, Param, Post, Query } from "@midwayjs/core";
import { ApiQuery, ApiTags } from "@midwayjs/swagger";
import { BaseController } from "../../frame/BaseController";
import { Validate } from "@midwayjs/validate";
import { omit, pick } from "lodash";
import { ServiceError, ErrorCode } from "../../error/service.error";
import { FVO_region, CVO_region } from "../../interface/system/region.interface";
import { MessageService } from "../../service/system/message.service";


const namePrefix = '消息';
@ApiTags(['消息'])
@Controller('/message', { tagName: namePrefix })
export class RegionController implements BaseController {
  controllerCode = 'system_message';
  @Inject()
  service: MessageService;

  @Get('/')
  @ApiTags('列表查询')
  @ApiQuery({ name: 'query' })
  async index(@Query() query: object) {
    const qobj = omit(query, ['skip', 'limit']);
    const others = pick(query, ['skip', 'limit']);
    const result = await this.service.query(qobj, others);
    return result;
  }

  @Get('/:id')
  @ApiTags('单查询')
  async fetch(@Param('id') id: number) {
    const data = await this.service.fetch({ id });
    const result = new FVO_region(data);
    return result;
  }

  @Post('/', { routerName: `创建${namePrefix}` })
  @ApiTags('创建数据')
  @Validate()
  async create(@Body() data: object) {
    const dbData = await this.service.create(data);
    const result = new CVO_region(dbData);
    return result;
  }

  @Post('/:id', { routerName: `修改${namePrefix}` })
  @ApiTags('修改数据')
  @Validate()
  async update(@Param('id') id: number, @Body() data: object) {
    if (!id) throw new ServiceError(ErrorCode.ID_NOT_FOUND);
    const result = await this.service.update({ id }, data);
    return result;
  }

  @Del('/:id', { routerName: `删除${namePrefix}` })
  @ApiTags('删除数据')
  @Validate()
  async delete(@Param('id') id: number) {
    if (!id) throw new ServiceError(ErrorCode.ID_NOT_FOUND);
    const result = await this.service.delete({ id });
    return result;
  }

}